﻿
:root {
    --dialog-spinner-background-color: rgba(0, 130, 255, 0.15);
}

body {
    padding-top: 50px;
    padding-bottom: 20px;
}

/* disable pinch-zoom on editor page */
body:has(#fullScreenContainer) * {
    touch-action: pan-x pan-y;
}

html {
    font-size: 14px;
}

/*Set padding to keep content from hitting the edges*/ 
.body-content {
    padding-left: 15px;
    padding-right: 15px;
    padding-top: 26px
}

.fcs-widged {
    border: none;
    padding: 0
}

/*Vendor can override button styles with higger specificity:
.fcs-mainArea-css-overrule-class .fcs-btn-toggle button
.fcs-mainArea-css-overrule-class .fcs-btn-toggle.fcs-btn-un-selected button
.fcs-mainArea-css-overrule-class .fcs-btn-toggle.fcs-btn-selected button
*/

.fcs-btn-toggle button {
    background-color: rgba(43, 131, 193, 0.92);
    /* border-color: #0c0d0e; */
    /* border: none; */
    color: white;
    border: 1px solid #337ab7;
    width: 85px;
    -webkit-box-sizing: border-box;
    -moz-box-sizing: border-box;
    box-sizing: border-box;
    padding: 1px 20px;
    margin: 1px 0px;
    border-radius: 0px;
}

.fcs-btn-un-selected button {
    background-color: #deebf7;
    color: #7da2b5;
    border: 1px solid #cee5f9;
}

.fcs-btn-selected button  {
}

.branchToggles {
    color: #333;
}

.fcs-tabStripComponentPage {
    max-height: 300px;
    max-height: 300px;
    overflow-y: auto;
    border: none;
    overflow: hidden;
}

/*The generated .k-widget.k-tooltip had some broken image in its definition in femcadstyle.css*/
.k-widget.k-tooltip {
    background-color: whitesmoke;
    opacity: 0.85;
}

.fcs-disabledstyle {
    pointer-events: none;
    opacity: 0.6;
}

/*Global fcs redefinition of the bootstrat container width in relation to the page width*/
/* width:90% is more than any other normal text page, but HiStuct is more an application than text page*/
.container { width: 90%; }

/*Common components styles for HiStruct component editor*/

/*loadingPropsContent is hosted in full size of pagePropertiesEditorClass*/
.loadingProps-timeline {
    position: absolute;
    left: 0px;
    top: 0px;
    width: 100%;
    height: 100%;
    text-align: right;
    box-sizing: border-box;
    padding-right: 5px;
    background-color: var(--dialog-spinner-background-color);
}

/* spinner fixed on top of dialog content */
/* inspired by: https://stackoverflow.com/a/40459794, https://stackoverflow.com/a/29175551 */
.loadingPropsContainer {
    position: absolute;
    left: 0;
    top: 0;
    bottom: 0;
    right: 0;
    background-color: var(--dialog-spinner-background-color);
}

.loadingProps {
    position: absolute;
    right: 20px;
}


.loading {
    display: none;
    position: absolute;
    left: 0;
    top: 0;
    width: 100%;
    height: 100%;
    background: rgba(255,255,255,0.8);
    color: black;
    z-index: 1000;
}

.loadingcontent {
    display: table;
    position: absolute;
    left: 0;
    width: 100%;
    height: 100%;
}

.loadingspinner {
    display: table-cell;
    vertical-align: middle;
    width: 100%;
    text-align: center;
    font-size: larger;
}

/*propertiesWindowClass hosts pagePropertiesEditorClass and sizes automatically 
    based on content which takes care of the overflow*/
.propertiesWindowClass {
    position: relative;
    height: auto;
    width: auto;
    overflow: hidden;
    padding: 0;
    transition: height 0.3s ease; /* Example: Smooth height transition */
    transition: width 0.3s ease; /* Example: Smooth height transition */
}

    .propertiesWindowClass.k-window-content {
        background-color: rgba(225, 225, 225, 0.95);
        overflow-y: auto;
    }

    .propertiesWindowClass .properties-window {
        padding: 12px;
        position: relative;
    }

/*pagePropertiesEditorClass takes care of the overflow,
    hosts scroll bar on the div with propertiesContentClass 
    and hosts progress spinner*/
.pagePropertiesEditorClass {
    position: relative;
    font-size: 11px;
    overflow-x: hidden;
    overflow-y: hidden;
    padding-right: 0px;
}

canvas {
    outline: none;
}

/*propertiesContentClass contains full size of the properties controls 
    and is thought to be hosted in something with scrollbar*/ 
.propertiesContentClass {
    position: relative;
    overflow : visible; 
    height: auto;
    width: auto;
    width: 100%;
    position: relative;
    margin: 10px 0px 10px 12px;
    padding-right: 12px;
    box-sizing: content-box;
}


/*Start - Styles referenced via the optional "CssStyleClass" property in the *.fcscdf file*/

.fcs-parameterItem-textNote {
    width: 350px;
    min-height: 50px;
	overflow-y: auto;
    word-wrap: break-word;
    text-align: left;
    white-space: normal;
    font-weight: normal;
}

.fcs-parameterItem-quoteButton {
    height: 40px;
    width: 100%;
}

.fcs-parameterItem-inMenuButton {
    height: 25px;
    width: 100%;
    font-weight: normal;
}

.fcs-legend {
    width: 100%;
    margin-bottom: 20px;
    font-size: 16px;
    font-weight: bold;
    border-bottom: 1px solid #e5e5e5;
}

.fcs-prop-value {
    text-align: right;
    position: relative;
}

.fcs-prop-value {
    text-align: right;
    position: relative;
}

.fcs-prop-value-editor {
    width: 85px;
}

.fcs-prop-value-editor-list {
    text-align: left;
}

.fcs-prop-value-spinner {
    position: absolute;
    right:7px;
    top:2px;
    z-index:2;
    height:12px;
    width:12px;
}

.fcs-prop-unit {
    text-align: left;
}

/*fcs-prop2-content-class contains full size of the properties controls and is thought to be hosted in something with scrollbar*/ 
.fcs-prop2-content-class {
    position: relative;
    overflow: visible;
    height: auto;
    width: auto;
    position: relative;
    /*margin: 10px 0px 10px 12px;*/
    padding-right: 12px;
}

    .fcs-prop2-content-class li {
        padding-left: 16px;
    }

    .propertiesWindowClass .k-content {
        background:none;
    }


.fcs-prop-row{
    display:flex;
    /* flex-flow:row wrap; */
}

    .fcs-prop-row .fcs-prop2-line {
        flex-grow:1
    }

    .fcs-prop-row user-arrow {
        flex-grow: 0
    }

.fcs-prop-sub-row {
    flex: 1 0;
}

ul.fcs-prop-sub-row {
  margin:0px;
}


.fcs-prop2-line {
    display: flex;
    align-items: center;
}

div.k-treeview.fcs-prop2-line {
    overflow-y: hidden;
}

    .fcs-prop2-line .fcs-prop2-name{
        padding:0px;
    }

    .k-treeview span.k-in {
        display: none;
    }

.fcs-prop2-name {
    flex-grow: 1;
    margin-right:15px;
}

user-arrow .fcs-arrow-link-class {
    color: aqua;
    position: absolute;
    margin: 4px;
    width: 15px;
    right: -11px;
    text-align: left;

    padding: 0;
    border: none;
    background: none;
}
    user-arrow i {
        cursor: pointer;
    }

user-arrow .fcs-arrow-link-class {
    color: gainsboro;
}

    user-arrow .fcs-arrow-link-class:focus {
        color: #fff;
        outline:none;
    }

    user-arrow .fcs-arrow-link-class:hover {
        color: #fff;
    }

/*Custom styling of mini-actions popover*/
.fcs-mini-actions-popover{

}

    .fcs-mini-actions-popover .popover-body {
        padding: 2px 2px 2px 4px;
    }

    .fcs-mini-actions-popover .list-group {
        margin-bottom: 0px;
    }

    .fcs-mini-actions-popover .list-group-item {
        font-size: 10px;
        padding: 2px 10px;
    }

    .fcs-mini-actions-popover .list-group-item {
        font-size: 10px;
        padding: 2px 10px;
    }

    .fcs-mini-actions-popover .list-group-item:first-child {
        border-top-right-radius: 2px;
        border-top-left-radius: 2px;
    }

    .fcs-mini-actions-popover .list-group-item:last-child {
        border-bottom-right-radius: 2px;
        border-bottom-left-radius: 2px;
    }

    .fcs-mini-actions-popover.popover {
        border-radius:4px;
    }

.fcs-dead-popover {
    pointer-events:none;
}

.fcs-prop-fromuser user-arrow .fcs-arrow-link-class {
    color: gray;
}

    .fcs-prop-fromuser user-arrow .fcs-arrow-link-class:hover {
        color: #fff;
    }

    .fcs-prop-fromuser user-arrow .fcs-arrow-link-class:focus {
        color: #fff;
    }

/*fcs own collapsible properties*/
.fcs-class-tree-collapsible-header{
    position:relative;
}

    .fcs-class-tree-collapsible-header::before {
        content: "\25BC";
        font-size: xx-small;
        position: absolute;
        left: -16px;
        top: 1px;
        color: #80808080;
        cursor: pointer;
        transform: rotate(0deg);
        transition: 0.5s ease-in-out;
    }


    .fcs-class-tree-collapsible-header.fcs-class-tree-collapsed::before {
        transform: rotate(-90deg);        
        transition: 0.5s ease-in-out;
    }


    .fcs-class-tree-collapsible-header label {
        margin: 0;
        cursor: pointer;
    }


.fcs-class-tree-collapsible-content {
/*    max-height:0px;
    transition: max-height 1.2s ease-out;
    overflow:hidden;
*/}

.fcs-class-tree-collapsible-header.fcs-class-tree-collapsed .fcs-class-tree-collapsible-toast {
    display: inline-flex;
}

.fcs-class-tree-collapsible-header .fcs-class-tree-collapsible-toast {
    display: none;
}

.fcs-class-tree-collapsible-toast-content {
    font-weight: normal;
}

/*Fixing of kendo tree*/

/*.fcs-prop2-name label {
        margin-bottom: auto;
        margin-top: auto;
    }*/
.k-treeview .tree-view-class.k-group li.k-last.k-item {
    margin-bottom: 5px;
}

.k-treeview .tree-view-class.k-group div.k-state-selected {
    background: none;
    color: #676767;
}

.k-treeview .tree-view-class.k-group div.k-state-focused {
    box-shadow: none;
    border:1px solid rgba(160,160,160,.4);
}


/* These are fixing the missing kendoTreeView*/

.fcs-properties-style-class .tree-view-class {
    padding-left: 0;
    list-style: none;
}

ul.tree-view-class li:not(.fcs-prop-row) {
    margin-top: 5px;
    margin-bottom: 5px;
}


label.fcs-prop2-label-toplevel {
    margin-left: 16px;
    margin-bottom: auto;
    margin-top: auto;
    margin-right: 8px;
}

.fcs-prop2-value {
    flex-grow: 0;
    flex-basis: 0;
    position: relative;
}
    .fcs-prop2-value .k-dropdown .k-dropdown-wrap .k-input {
        /* margin-left: 7px; */
    }

.k-textarea {
    min-width: 18em;
    min-height: 5.6em;

    .k-input {
        width: 18em;
        height: 5.6em;
        min-width: inherit;
        min-height: inherit;
    }
}

.fcs-prop2-value-double {
    display: inline-flex;
    align-items: center;
}
.fcs-prop2-value-double-editor {
    flex-grow: 0;
    position: relative; /*For the fcs-prop-value-spinner*/
}
.fcs-prop2-value-double-editor .k-numerictextbox{
    width: 85.5px;
}

.fcs-prop2-value-boolean {
    margin: 1px 0px;
}

.fcs-prop2-value-double-unit {
    flex-grow: 0;
    padding: 0px 3px;
    width: 45px;
}

.fcs-prop2-value-action {
    padding: 0 5px;
}

    .fcs-prop2-value-action button {
        margin: 5px 0;
    }

    .fcs-prop-row li .fcs-prop2-value-action button {
        display: block;
    }


load-properties-array-partial-view 
{
    display: flex;
}

#load-properties-array-window
{
    padding: 0;
}

load-properties-array-window-form {
    display: flex;
    flex-direction: column;
    height: 100%;
    width: 100%;
}

    load-properties-array-window-form .fcs-properties-array-tiles-list {
        border-bottom: 1px solid #ccc;
        min-height: 50px;
        overflow-y: auto;
        width: auto;
        flex: 1 1 auto;
        position: relative;
    }
        load-properties-array-window-form .fcs-properties-array-tiles-list ul.fcs-array-tiles-list {
            margin: 15px;
        }


.container.fcs-properties-array-table-list {
    border-bottom: 1px solid #ccc;
    max-height: 75vh;
    min-height: 50px;
    overflow-y: auto;
    width: 100%;
    padding: 0;
    flex: 1 1 auto;
    white-space: nowrap;
}
    .container.fcs-properties-array-table-list table {
        margin:15px;
    }

    .container.fcs-properties-array-table-list .fcs-prop2-value-double {
    }

    .container.fcs-properties-array-table-list .fcs-prop2-value-double-editor {
        width: max-content;
    }

    .container.fcs-properties-array-table-list .fcs-prop2-value-double-unit {
        display: none;
    }

    .container.fcs-properties-array-table-list .k-numerictextbox {
        min-width: 40px;
        max-width: 60px;
    }

    .container.fcs-properties-array-table-list .k-dropdown {
        min-width: 40px;
        width:100%;
    }

    .container.fcs-properties-array-table-list th {
        text-align: center;
        color: #333;
        width: 1px;
        padding: 4px 0px;
    }

    .container.fcs-properties-array-table-list th span{
        padding: inherit 2px;
    }



/* Tooltip needs to go over properties*/
.tooltip{
    z-index:11000;
}

.input-group spinner {
    z-index:3;
}

/*End - Styles referenced via the optional "CssStyleClass" property in the *.fcscdf file*/


/* custon badge*/
.data-badge-holder{
    position:relative;
}

    .data-badge-holder[data-count]:after {
        position: absolute;
        right: -12px;
        bottom: -10px;
        content: attr(data-count);
        font-size: 50%;
        padding: .6em;
        border-radius: 999px;
        line-height: .75em;
        color: white;
        background: rgba(255,0,0,.95);
        text-align: center;
        min-width: 2em;
        font-weight: lighter;
        font-family: sans-serif;
    }

.fcs-menu-button-class {
    position: relative;
    border: none;
    background: none;
    height: 100%;
    margin: 0;
    padding: 0;
    color: #1175b9;  /* removed important, because it kills disabled override*/
}

    .fcs-menu-button-class:disabled,
    .fcs-menu-button-class[disabled] {
        color: gray;
        pointer-events: none;
        cursor: not-allowed;
    }

    .fcs-menu-button-class:hover {
        background-color: #e7e7e7;
    }

    .fcs-menu-button-class:active {
        background-color: #555;
        color:white;
    }

    .fcs-menu-button-class:active .fa-inverse {
        color: #555;
    }

    .fcs-menu-button-class:focus {
        border: none;
        outline:none;
        /*outline: 1px solid #555;*/
    }



.fcs-menu-button-on-class {
    border: none;
    background: none;
    background-color: #555;
    color: white;
    outline:none;
}
    .fcs-menu-button-on-class:hover {
        background-color: #555;
        color:#e7e7e7;
    }

    .fcs-menu-button-on-class .fa-inverse {
        color: #555;
    }
    .fcs-menu-button-on-class:active .fa-inverse {
        color: #555;
    }

.menu-placeholder-class {
}


.fcs-right-side-panel-class {
    position: absolute;
    width: 48%;
    bottom: 0px;
    right: 0px;
    height: 100%;
    /*max-height: 400px;*/
    background-color: rgba(0,0,0,.8);
    padding: 10px;
    color: white;
    z-index:10;
}

/* tooltips were doing problems with mouse */
.tooltip {
    pointer-events: none;
}


/* inspiration from: https://stephanwagner.me/only-css-loading-spinner */
@keyframes input-spinner {
    to {
        transform: rotate(360deg);
    }
}

.input-spinner:after {
    content: '';
    text-align: right;
    box-sizing: border-box;
    position: absolute;
    left: 0;
    top: 0;
    right: 0;
    bottom: 0;
    background-color: var(--dialog-spinner-background-color);
    background-image: url("/images/progress/progress-properties-small05s.gif");
    background-repeat: no-repeat;
    background-size: 20px 20px;
    background-clip: padding-box;
    background-position: right 5px center;
    padding-right: 10px;
    z-index: 1010;
}

.input-spinner.k-dropdown:after {
    background-position: right 20px center;
}

.input-spinner {
    position: relative;
}

li.input-spinner:after,
.fcs-prop-row.input-spinner:after {
    left: -40px;
    top: -2px;
    right: -12px;
    bottom: -2px;
    background-size: 20px 20px;
    background-position: right 5px top 5px;
}

/* .fcs-prop-row.input-spinner:after {
    left: -40px;
    top: -2px;
    right: -12px;
    bottom: -2px;
    background-size: 20px 20px;
    background-position: right 5px top 5px;
} */

/* override default Bootstrap style >>> */
body {
    font-size: 14px;
    font-family: "Helvetica Neue", Helvetica, Arial, sans-serif;
}

/* change primary color */
.btn-primary {
    background-color: #337ab7 !important;
    color: white !important;
}
.btn-primary.active {
    background-color: #286090 !important;
}
.btn-primary:hover {
    background-color: #286090 !important;
}

.bg-primary {
    background-color: #337ab7 !important;
}

.btn-outline-primary {
    color: #286090 !important;
    border-color: #286090 !important;
    background-color: white !important;
}

    .btn-outline-primary:active, .btn-outline-primary:hover, .btn-outline-primary:focus {
        color: white !important;
        background-color: #286090 !important;
        border-color: #286090 !important;
    }

/* change dropdown style */
.dropdown-item.active {
    background-color: #337ab7 !important;
    color: white !important;
}
.dropdown-item:hover {
    -webkit-text-decoration: none !important;
    text-decoration: none !important;
}

/* change link style */
a, .btn-link, .nav-link {
    color: #337ab7;
    text-decoration: none;
}
a:hover, .btn-link:hover {
    color: #1175b9;
	text-decoration: underline;
    filter: brightness(0.75);
}
a.btn:hover, a.nav-link:hover {
    text-decoration: none;
}

/* override default table-pager style */
.page-item .page-link {
    color: #337ab7;
    text-decoration: none;
}

.page-item.active .page-link {
    color: white;
    background-color: #286090;
    border-color: #286090;
}

.page-item.disabled .page-link {
    color: #454545;
}

/* simulate missing btn-default */
.btn-default {
    color: #333;
    background-color: #fff;
    border-color: #ccc;
}
.btn-default:focus {
    color: #333;
    background-color: #e6e6e6;
    border-color: #8c8c8c;
}
.btn-default:hover {
    color: #333;
    background-color: #e6e6e6;
    border-color: #adadad;
}
.btn-default:active {
    color: #333;
    background-color: #e6e6e6;
    border-color: #adadad;
}

/* bring back BS3 label element style */
label {
    display: inline-block;
    max-width: 100%;
    margin-bottom: 0.5rem;
    /*font-weight: 700;*/       /* lets use the new weight*/
}

/* bring back BS4 form-X classes */
.form-group {
    margin-bottom: 1rem;
  }

/* adjust default container max width */
.container {
    max-width: 2048px; /* should be enough, NOTE: to simulate old behaviour, set to infinity (something big) */
}

.tooltip {
    font-size: 12px;
    font-family: Arial,sans-serif !important;
 }

.error-msg {
    margin: 0;
    padding: 0;
    overflow: hidden;
}

    .error-msg h3 {
        padding: 0;
        margin: 0;
        margin-bottom: 8px;
        font-size: 1.5rem;
        line-height: 1;
        overflow: hidden;
        text-overflow: ellipsis;
    }

    .error-msg p {
        overflow: hidden;
        text-overflow: ellipsis;
        padding: 0;
        margin: 0;
        max-height: 4.1em;
        min-height: 2.1em;
        line-height: 1em;
        white-space: normal;
    }

.k-notification .k-notification-content {
    width: 100%;
}

.pagePropertiesEditorClass h5 {
    font-size: 14px;
    margin-top: 10px;
    margin-bottom: 10px;
}

.pagePropertiesEditorClass label {
    font-weight: 700;
}

#drawingsButtonsEnvelope .btn {
    font-size: 14px;
}

.menu-placeholder-ineditor .fcs-menu-button-class {
    color: #454545 !important;
}

.focused-direct-edit-input {
    outline: 1px solid #00AAFF !important;
    color: #00AAFF !important;
}

@media 
    screen and (max-width: 1050px),
    screen and (max-height: 450px) {

    #fullScreenContainer #menuSearchBarPlaceholder {
        display: none;
    }

    .search-input-class input {
        width: 180px !important;
    }

    .navbar .fcs-menu-placeholder-button-content {
        padding-left: 0px;
        padding-right: 0px;
        width: 38px;
    }

    .navbar .navbar-with-right-margin {
        margin-right: 0 !important;
    }

    .container {
        width: 100%;
    }
}

.k-textbox > .k-input, .k-textbox > input {
    background-color: #ffffff;
    color: #676767;
}

/* override grid sort icon color */
 .hx-grid-sort-icon {
    color: #337ab7 !important;
} 